(* ======================================================================
 *  jcode.mli
 *
 *  Copyright (C) 2003 Shinya Kawanaka <mayah@mayah.jp> 
 * ======================================================================
 *)


(** ܸС *)

(** ƤȽǤ줿ʸɴʬΨǤߵͤĶƤǡȸʤ*)
val binary_level : int

(** guess_code ֤뷿 *)
type ktype_t =
    KT_UNKNOWN
  | KT_EUC_JP_or_SJIS
  | KT_ASCII
  | KT_JIS_X0201_ROMA
  | KT_JIS_X0201_KANA	
  | KT_JIS_X0212
  | KT_JIS_OLD
  | KT_JIS_OLD_X0201
  | KT_JIS_OLD_X0212
  | KT_JIS_OLD_BROKEN
  | KT_JIS_NEW
  | KT_JIS_NEW_X0201
  | KT_JIS_NEW_X0212
  | KT_JIS_NEW_BROKEN
  | KT_JIS_1990
  | KT_JIS_1990_X0212
  | KT_JIS_1990_BROKEN
  | KT_EUC_JP
  | KT_EUC_JP_X0212
  | KT_EUC_JP_BROKEN
  | KT_SJIS
  | KT_SJIS_BROKEN
  | KT_DATA

(** ̾Ȥ *)
type code_t =
  | UNKNOWN
  | ASCII
  | JIS
  | EUC
  | SJIS

(** ԥ *)
type lineend_t =
  | LF
  | CR
  | CRLF
;;

(** ɤɽ֤ *)
val string_of_code  : code_t -> string

(** Ʊ͡*)
val string_of_ktype : ktype_t -> string

(** ktype_t 顢code_t Ѵ롣*)
val code_of_ktype   : ktype_t -> code_t
 
(** [guess_from_channel ~size:size in_chan] ϡ[in_chan] Ƭ
    [size] ʸʾߤơʸɤȽ̤롣[size] άϡΤȤ 
    4096 Ȥ롣*)
val guess_from_channel : ?size:int -> in_channel -> ktype_t

(** [guess_from_string ~size:size str] ϡ[str] Ƭ
    [size] ʸʾߤơʸɤȽ̤롣[size] άϡΤȤ
    4096 Ȥ롣*)
val guess_from_string  : ?size:int -> string     -> ktype_t

(** [convert_from_channel_to_channel in_code out_code lineend zen2ascii
    in_chan out_chan] ϡ[in_chan] ɤ߹ߡʸɤѴƤ
    [out_chan] ˽Ϥ롣ʸɤ [in_code] ǻꤷʸɤϡ
    [out_code] ǻꤹ롣[in_code]  [UNKNOWN] ꤷϡʸɤ
    ꤵơŬѴ롣[out_chan]  [UNKNOWN] ꤷϡ
    [invalid_arg] ꤲ롣[zen2ascii]  [true] ꤹȡѱѿ
    ȾѱѿѴǤ롣[size] ˤϡʸɤꤹݤ˺¤٤٤
    ʸ롣ǥեȤǤ 4096 Ǥ롣*)
val convert_from_channel_to_channel :
    ?size:int -> code_t -> code_t -> lineend_t -> bool -> in_channel -> out_channel -> unit

(** [convert_from_channel_to_string in_code out_code lineend zen2ascii
    in_chan out_string] ϡ[in_chan] ɤ߹ߡ[out_string] ˽񤭽Фʳ
    [convert_from_channel_to_channel] ƱǤ롣*)
val convert_from_channel_to_string :
    ?size:int -> code_t -> code_t -> lineend_t -> bool -> in_channel -> string

(** string  channel ǤФʳƱǤ롣*)
val convert_from_string_to_channel :
    ?size:int -> code_t -> code_t -> lineend_t -> bool -> string -> out_channel -> unit

(** string  string ѴʳƱǤ롣*)
val convert_from_string_to_string :
    ?size:int -> code_t -> code_t -> lineend_t -> bool -> string -> string

(* ---------------------------------------------------------------------- *)

(* ûؿ̾ΥСʤϤäȤΤڤȡ*)

val guess_c : ?size:int -> in_channel -> ktype_t
val guess_s : ?size:int -> string     -> ktype_t
val conv_cc : ?size:int -> code_t -> code_t -> lineend_t -> bool -> in_channel -> out_channel -> unit
val conv_cs : ?size:int -> code_t -> code_t -> lineend_t -> bool -> in_channel -> string
val conv_sc : ?size:int -> code_t -> code_t -> lineend_t -> bool -> string -> out_channel -> unit
val conv_ss : ?size:int -> code_t -> code_t -> lineend_t -> bool -> string -> string
